/* Copyright (c) 2006, Sun Microsystems, Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *
 *     * Redistributions of source code must retain the above copyright notice,
 *       this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * Neither the name of the Sun Microsystems, Inc. nor the names of its
 *       contributors may be used to endorse or promote products derived from
 *       this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
 * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF
 * THE POSSIBILITY OF SUCH DAMAGE.
 */
// added to the original JJTree example
package examples.java.ex3jjt;

/*
 * We changed, from the original JJTree examples, the directory structure to comply to the maven
 *  directory structure, but to allow use of a custom node class ASTMyID it has to be under the
 *  JJTree generated classes directory (target/generated-tests/jj), so it is not under the normal
 *  maven java test classes directory (src/test/java).
 * Otherwise one would have to manually delete the generated
 *  target/generated-tests/jj/examples/java/ex3jjt/ASTMyID.java source after manual compilation
 *  by JJTree (or after the Eclipse project's automatic build).
 * This is handled in the build.xml.
 */

/**
 * An ID.
 */
public class ASTMyID extends SimpleNode {

  private String name;

  /**
   * Constructor.
   *
   * @param id the id
   */
  public ASTMyID(final int id) {
    super(id);
  }

  /**
   * Set the name.
   *
   * @param n the name
   */
  public void setName(final String n) {
    name = n;
  }

  /**
   * {@inheritDoc}
   *
   * @see org.javacc.examples.jjtree.eg2.SimpleNode#toString()
   */
  @Override
  public String toString() {
    return "Identifier: " + name;
  }

}
